package javax.swing;
import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.io.Serializable;
import javax.swing.plaf.*;


public abstract class AbstractButton extends JComponent {
    String text;

    protected ButtonModel model = new DefaultButtonModel();

    public ButtonModel getModel() {
	return model;
    }

    public void setModel(ButtonModel newModel) {
	if (model == newModel) return;
	
	if (ui != null) ui.uninstallUI(this);

	model = newModel;
	
	if (ui != null) ui.installUI(this);
    }

    public void setText(String txt) {
	text = txt;
	// schedule update?
    }

    public String getText() {
	return text;
    }

    public ButtonUI getUI() {
	return (ButtonUI) ui;
    }

    public void setUI(ButtonUI ui) {
	this.ui = ui;
    }

    protected void init() {
	updateUI();
    }






}
