package javax.swing;
import java.awt.ItemSelectable;
import java.awt.event.ActionListener;
import java.awt.event.ItemListener;
import java.awt.event.ActionListener;
import javax.swing.event.ChangeListener;

public interface ButtonModel extends ItemSelectable {
    
    boolean isArmed();

    boolean isSelected();

    boolean isEnabled();

    boolean isPressed();

    boolean isRollover();

    void setArmed(boolean armed);

    void setSelected(boolean selected);

    void setEnabled(boolean enabled);

    void setPressed(boolean pressed);


    void setRollover(boolean rollover);

    /* Have no idea why these is part of the *model* */
    void setMnemonic(int key);
    int getMnemonic();

    void setActionCommand(String command);
    String getActionCommand();

    //void setGroup(ButtonGroup group);

    void addActionListener(ActionListener listener);

    void removeActionListener(ActionListener listener);

    void addItemListener(ItemListener listener);

    void removeItemListener(ItemListener listener);

    void addChangeListener(ChangeListener listener);

    void removeChangeListener(ChangeListener listener);


}
