package no.rwr.image.hermes;

import java.awt.image.*;
import no.rwr.image.*;
import no.rwr.util.ArrayUtil;

public class HermesFactory implements RendererFactory {

    static boolean validState = initHermes();
    
    public static native boolean initHermes();

    public HermesFactory() {
	if (!validState) {
	    throw new IllegalStateException("hermes was not correctly " +
					    "initialized");
	}
    }

    

    public RasterOp createRenderer(ColorModel srcCM,
				   SampleModel srcSM,
				   ColorModel destCM,
				   SampleModel destSM) {
	HermesFormat srcFormat, destFormat;
	HermesConvertOp renderer;
	try {
	    srcFormat = new HermesFormat(srcCM, srcSM);
	    destFormat = new HermesFormat(destCM, destSM);
	    renderer = new HermesConvertOp();
	} catch (IllegalArgumentException iae) {
	    String msg = "not supported by hermes, " + iae;
	    throw new UnsupportedOperationException(msg);
	}
        renderer.setFormats(srcFormat, destFormat);
        return renderer;
    }
}
