package java.awt.event;

import java.awt.Component;
import java.awt.Point;


public class MouseEvent extends InputEvent {
    public static final int MOUSE_FIRST    = 500;
    public static final int MOUSE_LAST     = 506;
    public static final int MOUSE_CLICKED  = 500;
    public static final int MOUSE_PRESSED  = 501;
    public static final int MOUSE_RELEASED = 502;
    public static final int MOUSE_MOVED    = 503;
    public static final int MOUSE_ENTERED  = 504;
    public static final int MOUSE_EXITED   = 505;
    public static final int MOUSE_DRAGGED  = 506;

    int x, y, clickCount;
    boolean popupTrigger;
    
    public MouseEvent(Component source, int id, long when, int modifiers,
		      int x, int y, int clickCount, boolean popupTrigger) {
	super(source, id);
	this.x = x;
	this.y = y;
	this.clickCount = clickCount;
	this.popupTrigger = popupTrigger;
    }

    public int getX() {
	return x;
    }
    

    public int getY() {
	return y;
    }
    
    
    public Point getPoint() {
	return new Point(x, y);
    }
    

    public void translatePoint(int dx, int dy) {
	x += dx;
	y += dy;
    }

    public int getClickCount() {
	return clickCount;
    }

    public boolean isPopupTrigger() {
	return popupTrigger;
    }
    
    public String paramString() {
	return super.paramString() +
	    ",+" + x + "+" + y +
	    ",clickCount=" + clickCount +
	    (popupTrigger ? ",popupTrigger" : "");
    }
}
